;***************************************************************************************
;                           message.asm
;
;        .    
;  b (portb).      RB0 - RB4.
; :    . ,  " " 
;      .
;     RB0 - 4  RB.    
;    RA0       . 
;
;    .
; ,    A    :
; 0110
; 1001
; 1001       A.  1 =  . 0 =  .
; 1111
; 1001
;
;   Barry Carter
;          http://digitchip.by.ru
;
;***************************************************************************************

	LIST    P=16C84;f=inhx8m
	
w       equ     0			;   .
f       equ     1	
same	equ	1

z       equ     2			;  
zero	equ	2
c	equ	0
carry	equ	0
	
count1  equ     0C      		;      ( C)
count2  equ	0D			;      ( D)

portb   equ     06      		;  b ( f6)
porta	equ	05			;  a ( f5
status  equ     03     			;   f3
time	equ	.15                     ;    
;
;
;
	org     0			; origin
;
init   
	movlw   0			;  
	tris    portb                   ;    b   
	movwf   portb
	movlw	1
	tris	porta                   ;    a   
	bcf	porta,0

start
	goto	getbut 
	
;*     (HELLO) *

letters	call	lh			;    H.
	call	le	
	call	ll
	call	ll
	call	lo                      ;    O.
	goto	getbut			;     

;*     *

getbut	bcf	status,1
	movf	porta,w			;      RA.0
	movwf	status			;  ,    porta
	btfsc	status,0
	goto	getbut			; status = 1     
	goto	letters	                ; -    


;*         b *
;      l    la      a

;   A
la	call 	wait			; 
	movlw	B'00001111'		;       b
	movwf	portb
	call	wait	                ; 
	movlw	B'00010010'		;    
	movwf	portb
	call 	wait	                ; 
	movlw	B'00010010'		;    
	movwf	portb
	call 	wait	                ; 
	movlw	B'00001111'		;    
	movwf	portb
	call 	space1                  ;    
	return

;   B
lb	call 	wait
	movlw	B'00001111'
	movwf	portb
	call	wait
	movlw	B'00010101'
	movwf	portb
	call 	wait
	movlw	B'00010101'
	movwf	portb
	call 	wait
	movlw	B'00001010'
	movwf	portb
	call 	space1
	return

;   C
lc	call 	wait
	movlw	B'00001110'
	movwf	portb
	call	wait			 
	movlw	B'00010001'
	movwf	portb
	call 	wait
	movlw	B'00010001'
	movwf	portb
	call 	wait
	movlw	B'00010001'
	movwf	portb
	call 	space1
	return

;   D
ld	call 	wait
	movlw	B'00011111'
	movwf	portb
	call	wait			 
	movlw	B'00010001'
	movwf	portb
	call 	wait
	movlw	B'00010001'
	movwf	portb
	call 	wait
	movlw	B'00001110'
	movwf	portb
	call 	space1
	return
		

;   E
le	call 	wait
	movlw	B'00011111'
	movwf	portb
	call	wait			 
	movlw	B'00010101'
	movwf	portb
	call 	wait
	movlw	B'00010101'
	movwf	portb
	call 	wait
	movlw	B'00010101'
	movwf	portb
	call 	space1
	return

;   F
lf	call 	wait
	movlw	B'00011111'
	movwf	portb
	call	wait			 
	movlw	B'00010100'
	movwf	portb
	call 	wait
	movlw	B'00010100'
	movwf	portb
	call 	wait
	movlw	B'00010100'
	movwf	portb
	call 	space1
	return

;   G
lg	call 	wait
	movlw	B'00001110'
	movwf	portb
	call	wait			 
	movlw	B'00010001'
	movwf	portb
	call 	wait
	movlw	B'00010011'
	movwf	portb
	call 	wait
	movlw	B'00010011'
	movwf	portb
	call 	space1
	return

;   H
lh	call 	wait
	movlw	B'00011111'
	movwf	portb
	call	wait			 
	movlw	B'00000100'
	movwf	portb
	call 	wait
	movlw	B'00000100'
	movwf	portb
	call 	wait
	movlw	B'00011111'
	movwf	portb
	call 	space1
	return

;   I
li	call 	wait
	movlw	B'00010001'
	movwf	portb
	call	wait			 
	movlw	B'00001111'
	movwf	portb
	call 	wait
	movlw	B'00010001'
	movwf	portb
	call 	wait
	movlw	B'00000000'
	movwf	portb
	call 	space1
	return

;   J
lj	call 	wait
	movlw	B'00010010'
	movwf	portb
	call	wait			 
	movlw	B'00010001'
	movwf	portb
	call 	wait
	movlw	B'00011110'
	movwf	portb
	call 	wait
	movlw	B'00010000'
	movwf	portb
	call 	space1
	return

;   K
lk	call 	wait
	movlw	B'00011111'
	movwf	portb
	call	wait			 
	movlw	B'00000100'
	movwf	portb
	call 	wait
	movlw	B'00001010'
	movwf	portb
	call 	wait
	movlw	B'00010001'
	movwf	portb
	call 	space1
	return

;   L
ll	call 	wait
	movlw	B'0001111'
	movwf	portb
	call	wait			 
	movlw	B'00000001'
	movwf	portb
	call 	wait
	movlw	B'00000001'
	movwf	portb
	call 	wait
	movlw	B'00000001'
	movwf	portb
	call 	space1
	return

;   M
lm	call 	wait
	movlw	B'00001111'
	movwf	portb
	call	wait			 
	movlw	B'00011000'
	movwf	portb
	call 	wait
	movlw	B'00011000'
	movwf	portb
	call 	wait
	movlw	B'00001111'
	movwf	portb
	call 	space1
	return

;   N
ln	call 	wait
	movlw	B'00011111'
	movwf	portb
	call	wait			
	movlw	B'00001000'
	movwf	portb
	call 	wait
	movlw	B'00000100'
	movwf	portb
	call 	wait
	movlw	B'00011111'
	movwf	portb
	call 	space1
	return

;   O
lo	call 	wait
	movlw	B'00001110'
	movwf	portb
	call	wait			
	movlw	B'00010001'
	movwf	portb
	call 	wait
	movlw	B'00010001'
	movwf	portb
	call 	wait
	movlw	B'00001110'
	movwf	portb
	call 	space1
	return

;   P
lp	call 	wait
	movlw	B'00011111'
	movwf	portb
	call	wait			 
	movlw	B'00010100'
	movwf	portb
	call 	wait
	movlw	B'00010100'
	movwf	portb
	call 	wait
	movlw	B'00001000'
	movwf	portb
	call 	space1
	return

;   Q
lq	call 	wait
	movlw	B'00001110'
	movwf	portb
	call	wait			 
	movlw	B'00010001'
	movwf	portb
	call 	wait
	movlw	B'00010011'
	movwf	portb
	call 	wait
	movlw	B'00001111'
	movwf	portb
	call 	space1
	return

;   B
lr	call 	wait
	movlw	B'00011111'
	movwf	portb
	call	wait			 
	movlw	B'00010100'
	movwf	portb
	call 	wait
	movlw	B'00010110'
	movwf	portb
	call 	wait
	movlw	B'00001001'
	movwf	portb
	call 	space1
	return

;   S
ls	call 	wait
	movlw	B'00011101'
	movwf	portb
	call	wait			 
	movlw	B'00010101'
	movwf	portb
	call 	wait
	movlw	B'00010101'
	movwf	portb
	call 	wait
	movlw	B'00010111'
	movwf	portb
	call 	space1
	return

;   T
lt	call 	wait
	movlw	B'00010000'
	movwf	portb
	call	wait			 
	movlw	B'00011111'
	movwf	portb
	call 	wait
	movlw	B'00010000'
	movwf	portb
	call 	wait
	movlw	B'00000000'
	movwf	portb
	call 	space1
	return

;   U
lu	call 	wait
	movlw	B'00011111'
	movwf	portb
	call	wait			 
	movlw	B'00000001'
	movwf	portb
	call 	wait
	movlw	B'00000001'
	movwf	portb
	call 	wait
	movlw	B'00011111'
	movwf	portb
	call 	space1
	return

;   V
lv	call 	wait
	movlw	B'00011110'
	movwf	portb
	call	wait			 
	movlw	B'00000001'
	movwf	portb
	call 	wait
	movlw	B'00011110'
	movwf	portb
	call 	wait
	movlw	B'00000000'
	movwf	portb
	call 	space1
	return

;   W
lw	call 	wait
	movlw	B'00011110'
	movwf	portb
	call	wait			 
	movlw	B'00000011'
	movwf	portb
	call 	wait
	movlw	B'00000011'
	movwf	portb
	call 	wait
	movlw	B'00011110'
	movwf	portb
	call 	space1
	return

;   X
lx	call 	wait
	movlw	B'00010010'
	movwf	portb
	call	wait			 
	movlw	B'00001100'
	movwf	portb
	call 	wait
	movlw	B'00001100'
	movwf	portb
	call 	wait
	movlw	B'00010011'
	movwf	portb
	call 	space1
	return

;   Y
ly	call 	wait
	movlw	B'00010001'
	movwf	portb
	call	wait			 
	movlw	B'00001110'
	movwf	portb
	call 	wait
	movlw	B'00001000'
	movwf	portb
	call 	wait
	movlw	B'00010000'
	movwf	portb
	call 	space1
	return

;   Z
lz	call 	wait
	movlw	B'00010001'
	movwf	portb
	call	wait
	movlw	B'00010011'
	movwf	portb
	call 	wait
	movlw	B'00010101'
	movwf	portb
	call 	wait
	movlw	B'00011001'
	movwf	portb
	call 	space1
	return

;    
space1	movlw	B'00000000'		;      b
	call 	wait                    ;
	movlw	B'00000000'
	movwf	portb
	movlw	B'00000000'
	return

space2 	nop				; 
	goto	space2


;*    *

wait    
	movlw   time	        ;      count1  
	movwf   count1
d1	movlw   time		;      count2  
	movwf   count2	
				
	
d2	decfsz  count2,same	;  count2. ,   
	goto 	d2		; ,   		
	decfsz  count1		;  count1  count2  
	goto 	d1		;    ,    
	retlw 	00              ;   ,    
; ----------------------------        


END


